#!/bin/bash

# Script dat checkt of de P1 datalogger nog 
# up and running is. Indien het proces niet aanwezig is wordt er
# evt. een mail gestuurd naar <email-adres >   en wordt 
# het proces opnieuw gestart. 
# Om een e-mail te laten sturen verwijder het # voor de debetreffende regels. 
# Het script plus bijbehorende software start.sh en P1. Py staat  default in /opt/P1. 


# Datum : 19-04-2017
# Auteur: Peter Westerbeek 

# Dit script mag vrij gebruikt worden aangepast door iedereen, mits oorspronkelijke 
# auteur genoemd blijft. 

#MAILADRES="<email-adres>"

_TIJD=`date '+%d-%m-%Y %H:%M:%S'`
_BINDIR=/opt/p1
LOGDIR=/opt/p1/log/
LOGFILE=${LOGDIR}p1.log
MAXGROOTTE=1000000    # Roteer als groter dan 1Mb 

######################################################################################
# Function log_write : write log entries.
#
######################################################################################
log_write(){

LOGTIJD=`date '+%d-%m-%Y %H:%M:%S'`

if [ -f ${LOGFILE} ]
then
# Rotate logfile?

  GROOTTE=`ls -l ${LOGFILE}|awk '{print $5}'`
  if [ ${GROOTTE} -gt ${MAXGROOTTE} ]
  then
    mv ${LOGFILE} ${LOGFILE}.1
    echo "<${LOGTIJD}> Logfile geroteerd naar ${LOGFILE}.1  ." > ${LOGFILE} 2>/dev/null
  fi
  echo "<${LOGTIJD}> = $@" >> ${LOGFILE}
else
  if [  -d ${LOGDIR} ]
  then
	continue
  else
	mkdir ${LOGDIR}
  fi
  echo "<${LOGTIJD}> Logfile aangemaakt." > ${LOGFILE} 2>/dev/null
  if [ $? -ne 0 ]
  then
    echo "\nError : Can't write to logfile ${LOGFILE}."
    exit
  fi
  echo "<${LOGTIJD}> = $@" >> ${LOGFILE}
fi
}
 
echo "Script $0 wordt uitgevoerd op ${_HOSTNAAM}  "
log_write == Start Check van P1.py

WAAR=`ps -aef | grep "P1.py" | grep -v grep|wc -l | awk '{print $1}' `
echo "Status : ${WAAR}"
log_write Waarde Waar : ${WAAR}
if [ ${WAAR}  -eq 0 ]
then

#       Herstart de datalogger

	log_write Proces P1.py was gestopt en wordt opnieuw gestart
	echo "Herstart nodig van P1.py Cmd : ${_BINDIR}/start.sh "
	nohup ${_BINDIR}/start.sh &

#       Mail naar $MAILADRES...



#	echo "Subject: Inlees-script op de ${_HOSTNAAM} is opnieuw gestart." >/tmp/meel.$$
#	echo "Het inlees-script op de ${_HOSTNAAM} was onverwacht gestopt en is opnieuw opgestart op ${_TIJD}."  >>/tmp/meel.$$ 
#	echo "\nUw vriendelijke maildaemon op ${_HOSTNAAM}.\n"  >>/tmp/meel.$$
#	echo "\nDit is een automatisch gegenereerd bericht. Gelieve hierop niet te antwoorden."  >>/tmp/meel.$$
#	cat /tmp/meel.$$|mail ${MAILADRES}
#	echo "Er is een mail gestuurd naar ${MAILADRES}"
#	rm /tmp/meel.$$
else
	echo "Proces P1.py draait goed."
fi

log_write == Stop Check van P1.py
